> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/uwp/get-started/samples/contentreplacertest.md).

# ContentReplacer

Sample C# code to use Apryse SDK for searching and replacing text strings and images inside existing PDF files (e.g. business cards and other PDF templates). Unlike PDF forms, the ContentReplacer work

Sample C# code to use Apryse SDK for searching and replacing text strings and images inside existing PDF files (e.g. business cards and other PDF templates). Unlike PDF forms, the ContentReplacer works on actual PDF content and is not limited to static rectangular annotation regions. Learn more about our [UWP SDK](/core/get-started/frameworks/dotnet.md) and [PDF Editing & Manipulation Library](/core/page-manipulation/manipulation.md).

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
//
// Copyright (c) 2001-2020 by PDFTron Systems Inc. All Rights Reserved.
//

using System;
using System.IO;
using System.Threading.Tasks;
using Windows.Foundation;

using pdftron.PDF;

using PDFNetUniversalSamples.ViewModels;

namespace PDFNetSamples
{
    public sealed class ContentReplacerTest : Sample
    {
        public ContentReplacerTest() :
            base("ContentReplacer", "This sample shows how to use 'pdftron.PDF.ContentReplacer' to search and replace text strings and images in existing PDF (e.g. business cards and other PDF templates).")
        {
        }

        public override IAsyncAction RunAsync()
        {
            return Task.Run(new System.Action(async () => {
                WriteLine("--------------------------------");
                WriteLine("Starting ContentReplacer Test...");
                WriteLine("--------------------------------\n");
			    // The following example illustrates how to replace an image in a certain region,
			    // and how to change template text.
			    try
			    {
                    String input_file_path = Path.Combine(InputPath, "BusinessCardTemplate.pdf");
                    WriteLine("Opening input file " + input_file_path );
				    PDFDoc doc = new PDFDoc(input_file_path);
				    doc.InitSecurityHandler();

				    // first, replace the image on the first page
				    ContentReplacer replacer = new ContentReplacer();
                    pdftron.PDF.Page page = doc.GetPage(1);
                    //pdftron.SDF.SDFDoc sdoc = new pdftron.SDF.SDFDoc(doc);
                    pdftron.PDF.Image img = pdftron.PDF.Image.Create(doc.GetSDFDoc(), Path.Combine(InputPath, "peppers.jpg"));
				    replacer.AddImage(page.GetMediaBox(), img.GetSDFObj());
				    // next, replace the text place holders on the second page
				    replacer.AddString("NAME", "John Smith");
				    replacer.AddString("QUALIFICATIONS", "Philosophy Doctor"); 
				    replacer.AddString("JOB_TITLE", "Software Developer"); 
				    replacer.AddString("ADDRESS_LINE1", "#100 123 Software Rd"); 
				    replacer.AddString("ADDRESS_LINE2", "Vancouver, BC"); 
				    replacer.AddString("PHONE_OFFICE", "604-730-8989"); 
				    replacer.AddString("PHONE_MOBILE", "604-765-4321"); 
				    replacer.AddString("EMAIL", "info@pdftron.com"); 
				    replacer.AddString("WEBSITE_URL", "http://www.pdftron.com"); 
				    // finally, apply
				    replacer.Process(page);

                    String output_file_path = Path.Combine(OutputPath, "BusinessCard.pdf");
                    await doc.SaveAsync(output_file_path, 0);
				    doc.Destroy();
                    WriteLine("Done. Result saved in " + output_file_path);
                    await AddFileToOutputList(output_file_path).ConfigureAwait(false);
			    }
			    catch (Exception e)
			    {
                    WriteLine(GetExceptionMessage(e));
                }

			    // The following example illustrates how to replace text in a given region
			    try {
                    String input_file_path = Path.Combine(InputPath, "newsletter.pdf");
                    PDFDoc doc = new PDFDoc(input_file_path);
				    doc.InitSecurityHandler();

				    ContentReplacer replacer = new ContentReplacer();
                    pdftron.PDF.Page page = doc.GetPage(1);
                    pdftron.PDF.Rect target_region = page.GetMediaBox();
				    string replacement_text = "hello hello hello hello hello hello hello hello hello hello";
				    replacer.AddText(target_region, replacement_text);
				    replacer.Process(page);

                    String output_file_path = Path.Combine(OutputPath, "ContentReplaced.pdf");
                    await doc.SaveAsync(output_file_path, 0);
				    doc.Destroy();
                    WriteLine("Done. Result saved in " + output_file_path);
                    await AddFileToOutputList(output_file_path).ConfigureAwait(false);
			    }
			    catch (Exception e)
			    {
                    WriteLine(GetExceptionMessage(e));
                }
                WriteLine("\n--------------------------------");
                WriteLine("Done ContentReplacer Test.");
                WriteLine("--------------------------------\n");
            })).AsAsyncAction();
		}
	}
}
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/uwp/get-started/samples/contentreplacertest.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
